"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const rxjs_1 = require("rxjs");
const operators_1 = require("rxjs/operators");
const mapErrors = (result, error) => {
    if (error.children && error.children.length > 0) {
        return Object.assign(Object.assign({}, result), { [error.property]: error.children.reduce(mapErrors, {}) });
    }
    return Object.assign(Object.assign({}, result), { [error.property]: Object.values(error.constraints)[0] || '' });
};
let MapValidationErrorsInterceptor = class MapValidationErrorsInterceptor {
    intercept(context, next) {
        return next.handle().pipe(operators_1.catchError(error => {
            if (error.response && error.response.message && Array.isArray(error.response.message)) {
                const errors = error.response.message;
                return rxjs_1.of({ errors: errors.reduce(mapErrors, {}) });
            }
            else if (error.message &&
                error.message.message &&
                Array.isArray(error.message.message)) {
                const errors = error.message.message;
                return rxjs_1.of({ errors: errors.reduce(mapErrors, {}) });
            }
            return rxjs_1.throwError(error);
        }));
    }
};
MapValidationErrorsInterceptor = __decorate([
    common_1.Injectable()
], MapValidationErrorsInterceptor);
exports.MapValidationErrorsInterceptor = MapValidationErrorsInterceptor;
